<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
      integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N"
      crossorigin="anonymous"
    />
    <style>
      h3 {
        margin-bottom: 65px;
        color: #38d39f;
      }
      button {
        width: 100%;
      }
      .btn.btn-primary {
        background-color: #38d39f;
        font-size: 20px;
        font-family: Open Sans;
        font-style: normal;
        font-weight: 700;
        line-height: normal;
      }
      .confirm {
        display: flex;
        justify-content: center;
        margin-top: 27px;
        margin-bottom: 57px;
      }
      .hinh-des {
        display: flex;
        justify-content: flex-end;
      }
      .row {
        background-color: white;
        height: 80vh;
      }
      .recom {
        display: flex;
        justify-content: center;
      }
      a {
        color: #38d39f;
      }
    </style>
  </head>
  <body>
    <div class="container jumbotron mt-5">
      <div class="row">
        <div class="col-lg-6">
          <h3 id="the-h3">Create a free account</h3>
          <form id="regis-form">
            <div class="form-group">
              <label for="name">Name</label>
              <input
                type="text"
                class="form-control"
                id="name"
                aria-describedby="emailHelp"
                placeholder="Your Name"
                required
              />
            </div>
            <div class="form-group">
              <label for="exampleInputEmail1">Email</label>
              <input
                type="email"
                class="form-control"
                id="email"
                aria-describedby="emailHelp"
                placeholder="your email address"
                required
              />
            </div>
            <div class="form-group">
              <label for="password">Password</label>
              <input
                type="password"
                class="form-control"
                id="password"
                required
              />
            </div>
            <div class="form-group">
              <label for="confirm">Confirm Password</label>
              <input
                type="password"
                class="form-control"
                id="confirm-password"
                required
              />
            </div>
            <button type="submit" class="btn btn-primary">Sign Up</button>
            <div class="confirm">
              By signing up you agree to our&nbsp;<a
                href="link-to-terms-of-service"
                class="d-inline text-nowrap"
                >Terms of Service</a
              >&nbsp;and&nbsp;<a
                href="link-to-privacy-policy"
                class="d-inline text-nowrap"
                >Privacy Policy</a
              >.
            </div>
            <div class="recom">
              Already have an account?&nbsp;<a
                href="link-to-login"
                class="d-inline text-nowrap"
                >Login</a
              >.
            </div>
          </form>
        </div>
        <div class="col-lg-6">
          <div class="hinh-des">
            <img src="./imagem.png" alt="hinh" />
          </div>
        </div>
      </div>
    </div>
    <script>
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_STATUS_CREATED = 201;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
      const gBASE_URL_CONTACTS =
        "https://62458c222cfed18817229118.mockapi.io/contacts";
      var gInputForm = document.getElementById("regis-form");
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      gInputForm.addEventListener("submit", function (e) {
        //loai bo cac su kien mac dinh tren form
        e.preventDefault();

        //xu ly su kien login
        register();
      });
      function register() {
        //B0: khai bao doi tuong de thu thap du lieu
        var vRegisterData = {
          name: "",
          email: "",
          password: "",
          confirmpassword: "",
        };
        //B1: thu thap du lieu
        getRegisData(vRegisterData);

        //B2: kiem tra du lieu
        var vValid = validateRegisData(vRegisterData);

        if (vValid) {
          //B3: ket noi api
          const vRegisObj = new URLSearchParams(vRegisterData);
          var vXmlHttpRegis = new XMLHttpRequest();
          callRegisApi(vXmlHttpRegis, vRegisObj);

          vXmlHttpRegis.onreadystatechange = function () {
            if (
              this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
              this.status == gREQUEST_STATUS_CREATED
            ) {
              //B4: hien thi ket qua
              displayResult(vXmlHttpRegis.responseText);
            }
          };
        }
      }

      //ham thu thap du lieu
      function getRegisData(paramRegisData) {
        var vNameEle = document.getElementById("name");
        var vEmailEle = document.getElementById("email");
        var vpasswordEle = document.getElementById("password");
        var vConfirmPass = document.getElementById("confirm-password");

        paramRegisData.name = vNameEle.value;
        paramRegisData.email = vEmailEle.value;
        paramRegisData.password = vpasswordEle.value;
        paramRegisData.confirmpassword = vConfirmPass.value;
      }
      //ham kiem tra du lieu
      function validateRegisData(paramRegisData) {
        //kiem tra dinh dạng email
        if (paramRegisData.name === "") {
          alert("Tên không để trống");
          return false;
        }
        if (!validateEmail(paramRegisData.email)) {
          alert("Email không đúng định dạng");
          return false;
        }

        //kiem tra dinh dang password
        if (paramRegisData.password.length < 5) {
          alert("Độ dài mật khẩu phải từ 5 ký tự");
          return false;
        }
        //kiem tra đúng password
        if (paramRegisData.password !== paramRegisData.confirmpassword) {
          alert("Mật khẩu khác mật khẩu đã nhập");
          return false;
        }
        return true;
      }

      function validateEmail(paramEmail) {
        var vRegexEmail = /^[a-zA-Z0-9_]+@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*$/;
        if (paramEmail.match(vRegexEmail)) {
          return true;
        } else {
          return false;
        }
      }

      function callRegisApi(paramXmlHttpRegis, paramRegisObj) {
        paramXmlHttpRegis.open(
          "POST",
          gBASE_URL + "?" + paramRegisObj.toString(),
          true
        );
        paramXmlHttpRegis.send();
      }

      //Hàm hiển thị kết quả
      function displayResult(paramRegisData) {
        console.log(paramRegisData);
      }
    </script>
  </body>
</html>
